<?php
namespace User\Service;



/**
 * Registration, login and forgot password functionality.
 * @author andre.fourie
 */
class Registration extends \User\DataBin\Registration
{

	/**
	 * ExecuteAfter: RegisterFinal.
	 * Register a new dealership and its primary user.
	 * @param array $meta
	 * @param object|null $jobRecord
	 * @param object|null $record
	 * @param \Workspace\Utility\ServiceInputParams $contract
	 * @return array
	 */
	public function RegisterCompany($meta, $jobRecord, $session, \Workspace\Utility\ServiceInputParams $contract)
	{
		$contactService = new \Person\Service\Contact();
		$contactService->setWorkflow(new \Person\Workflow());
		$companyService = new \Company\Service\Company();
		$companyService->setWorkflow(new \Company\Workflow());
		$profileService = new \User\Service\Profile();
		$profileService->setWorkflow(new \User\Workflow());
		//\Utility\Debug::errorLog('create contact', $session->Contact);

		$session->Contact['firstName']=$session->Profile['firstName'];
		$session->Contact['familyName']=$session->Profile['familyName'];
		$session->Contact['email']=$session->Profile['email'];
		$session->Contact['mobile']=$session->Profile['mobile'];


		$contact = $contactService->create($session->Contact);
		$session->Company['contact'] = $contact->id;
		$session->Company['name']= $session->Profile['firstName'].' '.$session->Profile['familyName'];
		$session->Company['businessName']= $session->Profile['firstName'].' '.$session->Profile['familyName'];
		$session->Company['group']= '3';
		$session->Company['groupDivision']= '3';
//		$session->Company['region']= '1';
//		$session->Company['city']= '1';
//		if (isset($session->BillingContact))
//		{
//		//\Utility\Debug::errorLog('create billing contact', $session->BillingContact);
//			$billingContact = $contactService->create($session->BillingContact);
//			$session->Company['contbillingContactact'] = $billingContact->id;
//		}
		//\Utility\Debug::errorLog('create company', $session->Company);
		$company = $companyService->create($session->Company);
		$session->Profile['company'] = $company->id;
//		if ($session->Profile['permissions'] < 5 || $session->Profile['permissions'] > 8)
//		{
//			$session->Profile['permissions'] = 5;
//		}
		$session->Profile['permissions'] = 12;
		\Utility\Debug::errorLog('create profile', $session->Profile);
		$profile = $profileService->create($session->Profile);

		$toCompanyId	= '';
		$toProfileId	= $profile->id;
		$email			= $profile->email;
		$mobile			= null;
		$subject		= null;
		$templateName	= 'activation-pending';

		$params = array();
		$params['firstName']	= $profile->firstName;
		$params['familyName']	= $profile->familyName;
		$params['message'] 		= 'Thank you for registering. Your registration was submitted for approval '
								. 'and you will receive email confirmation once your account has been verified.';

		#-> Send welcome notification to User.
		$oNotify = new \Utility\Comms\Notification();
		$oNotify->sendFromTemplate(
				null, null,
				$toCompanyId, $toProfileId,
				$email, $mobile,
				$subject,
				$templateName,
				$params
		);
		
		
		#-> Send welcome notification to Admin.
		$oNotify = new \Utility\Comms\Notification();
		$oNotify->sendFromTemplate(
				null, null,
				$toCompanyId, $toProfileId,
				'info@bid4cars.com.na', $mobile,
				$subject,
				$templateName,
				$params
		);
	}

}